;; This file:
;;   http://anggtwu.net/elisp/klapt.el.html
;;   http://anggtwu.net/elisp/klapt.el
;;          (find-angg "elisp/klapt.el")
;; Author: Eduardo Ochs <eduardoochs@gmail.com>
;;
;; Version: 2023oct30
;; Try: (load (buffer-file-name))
;;      (eek "2*<down> <klapt>")
;;   «foo»  (to ".foo")
;;   (find-bortolossi3page (+ -78 106)   "[14] (O plano)")

;;
;; (find-eev "eev-kla.el" "generate-sexps")
;; (find-eev "eev-kla.el" "kill-sexps")
;; (find-eev "eev-kla.el" "aliases")
;;
;; (defun e () (interactive) (find-angg "elisp/klapt.el"))

;; See: (find-angg ".emacs.templates" "find-tikzsearch2-links")

(cl-defun ee-kl-sexp-at-eol (&key sexp)
  (or sexp (progn (ee-goto-eol) (read (ee-last-sexp)))))

(cl-defun ee-kl-sexp-at-eol-p (&key sexp pp p)
  (setq sexp (or sexp (ee-kl-sexp-at-eol))
        pp   (or pp   (nth 1 sexp))
        p    (or p    (if (numberp pp) pp (nth 2 pp))))
  (format "%s" p))

(cl-defun ee-kl-sexp-at-eol-text (&key sexp text)
  (setq sexp (or sexp (ee-kl-sexp-at-eol))
        text (or text (nth 2 sexp)))
  text)

(cl-defun ee-kl-sexp-klapt (&key fname c r anchor sexp p text)
  (setq fname  (or fname  (ee-kl-fname))
	c      (or c      (ee-kl-c :fname fname))
	r      (or r      (ee-kl-r :fname fname))
	anchor (or anchor (ee-kl-anchor))
	sexp   (or sexp   (ee-kl-sexp-at-eol))
	p      (or p      (ee-kl-sexp-at-eol-p    :sexp sexp :p p))
	text   (or text   (ee-kl-sexp-at-eol-text :sexp sexp :text text))
	)
  (list (ee-kl-find-c       :fname fname :c c)
	(ee-kl-shorterfname :fname fname :c c :r r)
	anchor
	p
	text))

(defun eeklapt ()
  (interactive)
  (ee-kl-kill (ee-kl-sexp-klapt)))

(defalias 'klapt 'eeklapt)
